Index: /code/trunk/src/modules/questsystem/notifications/NotificationManager.h
===================================================================
--- /code/trunk/src/modules/questsystem/notifications/NotificationManager.h	(revision 5928)
+++ /code/trunk/src/modules/questsystem/notifications/NotificationManager.h	(revision 5929)
@@ -41,10 +41,9 @@
 #include <string>
 
-#include "util/ScopedSingleton.h"
+#include "util/Singleton.h"
 #include "core/OrxonoxClass.h"
 
 namespace orxonox
 {
-
     /**
     @brief
@@ -54,7 +53,7 @@
         Damian 'Mozork' Frick
     */
-    class _QuestsystemExport NotificationManager : public ScopedSingleton<NotificationManager, ScopeID::GSLevel>, public OrxonoxClass
+    class _QuestsystemExport NotificationManager : public Singleton<NotificationManager>, public OrxonoxClass
     {
-            friend class ScopedSingleton<NotificationManager, ScopeID::GSLevel>;
+            friend class Singleton<NotificationManager>;
         public:
             NotificationManager();
Index: /code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc
===================================================================
--- /code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc	(revision 5928)
+++ /code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc	(revision 5929)
@@ -426,5 +426,5 @@
         this->containers_.erase(container);
         this->overlays_.erase(container->notification);
-        delete container->overlay;
+        container->overlay->destroy();
         delete container;
         this->size_= this->size_-1;
Index: /code/trunk/src/modules/weapons/MuzzleFlash.cc
===================================================================
--- /code/trunk/src/modules/weapons/MuzzleFlash.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/MuzzleFlash.cc	(revision 5929)
@@ -41,13 +41,6 @@
         RegisterObject(MuzzleFlash);
         this->setScale(0.1f);
-        
-        this->delayTimer_.setTimer(0.1f, false, this, createExecutor(createFunctor(&MuzzleFlash::destroy)));
 
+        this->delayTimer_.setTimer(0.1f, false, createExecutor(createFunctor(&MuzzleFlash::destroy, this)));
     }
-
-    void MuzzleFlash::destroy()
-    {
-        delete this;
-    }
- 
 }
Index: /code/trunk/src/modules/weapons/MuzzleFlash.h
===================================================================
--- /code/trunk/src/modules/weapons/MuzzleFlash.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/MuzzleFlash.h	(revision 5929)
@@ -43,10 +43,6 @@
             virtual ~MuzzleFlash() {}
 
-
-
         private:
-            void destroy();
-            Timer<MuzzleFlash> delayTimer_;
-
+            Timer delayTimer_;
     };
 }
Index: /code/trunk/src/modules/weapons/WeaponsPrereqs.h
===================================================================
--- /code/trunk/src/modules/weapons/WeaponsPrereqs.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/WeaponsPrereqs.h	(revision 5929)
@@ -28,6 +28,7 @@
 
 /**
-  @file
-  @brief Contains all the necessary forward declarations for all classes and structs.
+@file
+@brief
+    Shared library macros, enums, constants and forward declarations for the weapons module
 */
 
@@ -36,5 +37,4 @@
 
 #include "OrxonoxConfig.h"
-
 #include "OrxonoxPrereqs.h"
 
@@ -42,4 +42,5 @@
 // Shared library settings
 //-----------------------------------------------------------------------
+
 #if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
 #  ifdef WEAPONS_SHARED_BUILD
@@ -64,20 +65,23 @@
 namespace orxonox
 {
-    class LaserFire;
+    class MuzzleFlash;
+
+    // munitions
+    class FusionMunition;
+    class LaserMunition;
+    class ReplenishingMunition;
+
+    // projectiles
+    class BillboardProjectile;
+    class LightningGunProjectile;
+    class ParticleProjectile;
+    class Projectile;
+
+    // weaponmodes
+    class EnergyDrink;
     class FusionFire;
     class HsW01;
+    class LaserFire;
     class LightningGun;
-    class EnergyDrink;
-
-    class Projectile;
-    class BillboardProjectile;
-    class ParticleProjectile;
-    class LightningGunProjectile;
-
-    class ReplenishingMunition;
-    class LaserMunition;
-    class FusionMunition;
-
-    class MuzzleFlash;
 }
 
Index: /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.cc
===================================================================
--- /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 5929)
@@ -44,5 +44,5 @@
         // replenishIntervall_ and replenishMunitionAmount_ will be set in the constructor of the
         // inheriting class, which comes after this constructor)
-        this->replenishingTimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&ReplenishingMunition::initializeTimer)));
+        this->replenishingTimer_.setTimer(0.0f, false, createExecutor(createFunctor(&ReplenishingMunition::initializeTimer, this)));
     }
 
@@ -50,5 +50,5 @@
     {
         // Initialize the timer
-        this->replenishingTimer_.setTimer(this->replenishIntervall_, true, this, createExecutor(createFunctor(&ReplenishingMunition::replenish)));
+        this->replenishingTimer_.setTimer(this->replenishIntervall_, true, createExecutor(createFunctor(&ReplenishingMunition::replenish, this)));
     }
 
Index: /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.h
===================================================================
--- /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/munitions/ReplenishingMunition.h	(revision 5929)
@@ -51,5 +51,5 @@
             void initializeTimer();
 
-            Timer<ReplenishingMunition> replenishingTimer_;
+            Timer replenishingTimer_;
     };
 }
Index: /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 5929)
@@ -42,5 +42,5 @@
         this->textureIndex_ = 1;
         this->maxTextureIndex_ = 8;
-        this->textureTimer_.setTimer(0.01f, true, this, createExecutor(createFunctor(&LightningGunProjectile::changeTexture)));
+        this->textureTimer_.setTimer(0.01f, true, createExecutor(createFunctor(&LightningGunProjectile::changeTexture, this)));
         
         registerVariables();
Index: /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 5929)
@@ -50,5 +50,5 @@
             unsigned int textureIndex_;
             unsigned int maxTextureIndex_;
-            Timer<LightningGunProjectile> textureTimer_;
+            Timer textureTimer_;
             std::string materialBase_;
       private:
Index: /code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 5929)
@@ -59,5 +59,5 @@
         {
             this->detachOgreObject(this->particles_->getParticleSystem());
-            delete this->particles_;
+            this->particles_->destroy();
         }
     }
Index: /code/trunk/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 5929)
@@ -61,5 +61,5 @@
             this->attachCollisionShape(shape);
 
-            this->destroyTimer_.setTimer(this->lifetime_, false, this, createExecutor(createFunctor(&Projectile::destroyObject)));
+            this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&Projectile::destroyObject, this)));
         }
     }
@@ -84,5 +84,5 @@
 
         if (this->bDestroy_)
-            delete this;
+            this->destroy(); // TODO: use a scheduler instead of deleting the object right here in tick()
     }
 
@@ -90,5 +90,5 @@
     {
         if (GameMode::isMaster())
-            delete this;
+            this->destroy();
     }
 
@@ -133,8 +133,7 @@
     }
 
-    void Projectile::destroyedPawn(Pawn* pawn)
+    void Projectile::setOwner(Pawn* owner)
     {
-        if (this->owner_ == pawn)
-            this->owner_ = 0;
+        this->owner_ = owner;
     }
 }
Index: /code/trunk/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 5929)
@@ -33,10 +33,9 @@
 
 #include "tools/Timer.h"
-#include "interfaces/PawnListener.h"
 #include "worldentities/MovableEntity.h"
 
 namespace orxonox
 {
-    class _WeaponsExport Projectile : public MovableEntity, public PawnListener
+    class _WeaponsExport Projectile : public MovableEntity
     {
         public:
@@ -49,5 +48,4 @@
             virtual void tick(float dt);
             virtual bool collidesAgainst(WorldEntity* otherObject, btManifoldPoint& contactPoint);
-            virtual void destroyedPawn(Pawn* pawn);
 
             inline void setDamage(float damage)
@@ -56,15 +54,14 @@
                 { return this->damage_; }
 
-            inline void setOwner(Pawn* owner)
-                { this->owner_ = owner; }
+            void setOwner(Pawn* owner);
             inline Pawn* getOwner() const
                 { return this->owner_; }
 
         private:
-            Pawn* owner_;
+            WeakPtr<Pawn> owner_;
             float lifetime_;
             float damage_;
             bool bDestroy_;
-            Timer<Projectile> destroyTimer_;
+            Timer destroyTimer_;
     };
 }
Index: /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.cc
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 5929)
@@ -54,5 +54,5 @@
         this->setMunitionName("FusionMunition");
 
-        this->delayTimer_.setTimer(1.0f, false, this, createExecutor(createFunctor(&EnergyDrink::shot)));
+        this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&EnergyDrink::shot, this)));
         this->delayTimer_.stopTimer();
     }
Index: /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 5929)
@@ -59,5 +59,5 @@
             float speed_;
             float delay_;
-            Timer<EnergyDrink> delayTimer_;
+            Timer delayTimer_;
     };
 }
Index: /code/trunk/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/HsW01.cc	(revision 5928)
+++ /code/trunk/src/modules/weapons/weaponmodes/HsW01.cc	(revision 5929)
@@ -54,5 +54,5 @@
         this->setMunitionName("LaserMunition");
 
-        this->delayTimer_.setTimer(1.0f, false, this, createExecutor(createFunctor(&HsW01::shot)));
+        this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&HsW01::shot, this)));
         this->delayTimer_.stopTimer();
     }
Index: /code/trunk/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/HsW01.h	(revision 5928)
+++ /code/trunk/src/modules/weapons/weaponmodes/HsW01.h	(revision 5929)
@@ -57,5 +57,5 @@
             float speed_;
             float delay_;
-            Timer<HsW01> delayTimer_;
+            Timer delayTimer_;
     };
 }
Index: /code/trunk/src/orxonox/CMakeLists.txt
===================================================================
--- /code/trunk/src/orxonox/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/orxonox/CMakeLists.txt	(revision 5929)
@@ -25,18 +25,19 @@
 
 SET_SOURCE_FILES(ORXONOX_SRC_FILES
+  Level.cc
+  LevelManager.cc
   Main.cc
-
-  CameraManager.cc
-  LevelManager.cc
   PawnManager.cc
   PlayerManager.cc
-
-  Level.cc
   Radar.cc
+COMPILATION_BEGIN SceneCompilation.cc
+  CameraManager.cc
   Scene.cc
+COMPILATION_END
 )
 
 ADD_SUBDIRECTORY(collisionshapes)
 ADD_SUBDIRECTORY(controllers)
+ADD_SUBDIRECTORY(gamestates)
 ADD_SUBDIRECTORY(gametypes)
 ADD_SUBDIRECTORY(graphics)
Index: /code/trunk/src/orxonox/CameraManager.cc
===================================================================
--- /code/trunk/src/orxonox/CameraManager.cc	(revision 5928)
+++ /code/trunk/src/orxonox/CameraManager.cc	(revision 5929)
@@ -26,4 +26,5 @@
  *
  */
+
 #include "CameraManager.h"
 
@@ -34,6 +35,8 @@
 #include "util/StringUtils.h"
 #include "core/GameMode.h"
+#include "core/GraphicsManager.h"
 #include "core/GUIManager.h"
 #include "core/ObjectList.h"
+#include "core/ScopedSingletonManager.h"
 #include "tools/Shader.h"
 #include "graphics/Camera.h"
@@ -43,20 +46,20 @@
 {
     CameraManager* CameraManager::singletonPtr_s = 0;
+    ManageScopedSingleton(CameraManager, ScopeID::Graphics, false);
 
-    CameraManager::CameraManager(Ogre::Viewport* viewport)
-        : viewport_(viewport)
+    CameraManager::CameraManager()
+        : viewport_(GraphicsManager::getInstance().getViewport())
     {
-        this->fallbackCamera_ = 0;
+        assert(GameMode::showsGraphics());
     }
 
     CameraManager::~CameraManager()
     {
-        if (this->fallbackCamera_)
-            this->fallbackCamera_->getSceneManager()->destroyCamera(this->fallbackCamera_);
+        GUIManager::getInstance().setCamera(0);
     }
 
     Camera* CameraManager::getActiveCamera() const
     {
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             return this->cameraList_.front();
         else
@@ -66,23 +69,16 @@
     void CameraManager::requestFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            return;
-
         // notify old camera (if it exists)
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             this->cameraList_.front()->removeFocus();
-        else if (this->fallbackCamera_)
-        {
-            this->fallbackCamera_->getSceneManager()->destroyCamera(this->fallbackCamera_);
-            this->fallbackCamera_ = 0;
-        }
 
         camera->setFocus();
 
         // make sure we don't add it twice
-        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end(); ++it)
+        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end();)
             if ((*it) == camera)
-                return;
-
+                this->cameraList_.erase(it++);
+            else
+                ++it;
         // add to list
         this->cameraList_.push_front(camera);
@@ -91,9 +87,6 @@
     void CameraManager::releaseFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            return;
-
         // notify the cam of releasing the focus
-        if (this->cameraList_.front() == camera)
+        if (!this->cameraList_.empty() && this->cameraList_.front() == camera)
         {
             camera->removeFocus();
@@ -101,18 +94,9 @@
 
             // set new focus if possible
-            if (this->cameraList_.size() > 0)
+            if (!this->cameraList_.empty())
                 this->cameraList_.front()->setFocus();
-            else
-            {
-                // there are no more cameras, create a fallback
-                if (!this->fallbackCamera_)
-                    this->fallbackCamera_ = camera->getScene()->getSceneManager()->createCamera(getUniqueNumberString());
-                this->useCamera(this->fallbackCamera_);
-            }
         }
         else
-        {
             this->cameraList_.remove(camera);
-        }
     }
 
Index: /code/trunk/src/orxonox/CameraManager.h
===================================================================
--- /code/trunk/src/orxonox/CameraManager.h	(revision 5928)
+++ /code/trunk/src/orxonox/CameraManager.h	(revision 5929)
@@ -42,12 +42,14 @@
 #include "util/OgreForwardRefs.h"
 #include "util/Singleton.h"
+#include "core/OrxonoxClass.h"
+#include "core/SmartPtr.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport CameraManager : public Singleton<CameraManager>
+    class _OrxonoxExport CameraManager : public Singleton<CameraManager>, public OrxonoxClass
     {
             friend class Singleton<CameraManager>;
         public:
-            CameraManager(Ogre::Viewport* viewport);
+            CameraManager();
             ~CameraManager();
 
@@ -66,5 +68,4 @@
             std::list<Camera*>    cameraList_;
             Ogre::Viewport*       viewport_;
-            Ogre::Camera*         fallbackCamera_;
 
             static CameraManager* singletonPtr_s;
Index: /code/trunk/src/orxonox/Level.cc
===================================================================
--- /code/trunk/src/orxonox/Level.cc	(revision 5928)
+++ /code/trunk/src/orxonox/Level.cc	(revision 5929)
@@ -30,5 +30,4 @@
 
 #include "util/Math.h"
-#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/Loader.h"
@@ -40,5 +39,4 @@
 #include "gametypes/Gametype.h"
 #include "overlays/OverlayGroup.h"
-#include "sound/SoundBase.h"
 #include "LevelManager.h"
 
@@ -53,4 +51,5 @@
         this->registerVariables();
         this->xmlfilename_ = this->getFilename();
+        this->xmlfile_ = 0;
     }
 
@@ -64,7 +63,4 @@
             if (this->xmlfile_)
                 Loader::unload(this->xmlfile_);
-
-            if(this->ambientsound_ != NULL)
-                delete this->ambientsound_;
         }
     }
@@ -76,6 +72,4 @@
         XMLPortParam(Level, "description", setDescription, getDescription, xmlelement, mode);
         XMLPortParam(Level, "gametype", setGametypeString, getGametypeString, xmlelement, mode).defaultValues("Gametype");
-
-        XMLPortParamLoadOnly(Level, "ambientsound", loadAmbientSound, xmlelement, mode);
 
         XMLPortObjectExtended(Level, BaseObject, "", addObject, getObject, xmlelement, mode, true, false);
@@ -116,10 +110,6 @@
             this->gametype_ = gametype;
 
-std::cout << "Load Gametype: " << this->gametype_ << std::endl;
-
         Gametype* rootgametype = orxonox_cast<Gametype*>(identifier->fabricate(this));
         this->setGametype(rootgametype);
-
-std::cout << "root gametype: " << rootgametype->getIdentifier()->getName() << std::endl;
 
         for (std::list<BaseObject*>::iterator it = this->objects_.begin(); it != this->objects_.end(); ++it)
@@ -149,19 +139,4 @@
     }
 
-    void Level::loadAmbientSound(const std::string& filename)
-    {
-        if(filename == "") return;
-        else
-        {
-            if(this->ambientsound_ == NULL)
-            {
-                this->ambientsound_ = new SoundBase();
-            }
-
-            this->ambientsound_->loadFile(filename);
-            this->ambientsound_->play(true);
-        }
-    }
-
     void Level::playerEntered(PlayerInfo* player)
     {
Index: /code/trunk/src/orxonox/Level.h
===================================================================
--- /code/trunk/src/orxonox/Level.h	(revision 5928)
+++ /code/trunk/src/orxonox/Level.h	(revision 5929)
@@ -53,6 +53,4 @@
                 { return this->description_; }
 
-            void loadAmbientSound(const std::string& filename);
-
             void playerEntered(PlayerInfo* player);
             void playerLeft(PlayerInfo* player);
@@ -73,6 +71,4 @@
             XMLFile*               xmlfile_;
             std::list<BaseObject*> objects_;
-
-            SoundBase*             ambientsound_;
     };
 }
Index: /code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- /code/trunk/src/orxonox/LevelManager.cc	(revision 5928)
+++ /code/trunk/src/orxonox/LevelManager.cc	(revision 5929)
@@ -34,10 +34,9 @@
 #include "core/CommandLine.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/Loader.h"
+#include "core/ScopedSingletonManager.h"
 #include "PlayerManager.h"
 #include "Level.h"
-#include "infos/HumanPlayer.h"
 
 namespace orxonox
@@ -46,4 +45,5 @@
 
     LevelManager* LevelManager::singletonPtr_s = 0;
+    ManageScopedSingleton(LevelManager, ScopeID::Root, false);
 
     LevelManager::LevelManager()
Index: /code/trunk/src/orxonox/Main.cc
===================================================================
--- /code/trunk/src/orxonox/Main.cc	(revision 5928)
+++ /code/trunk/src/orxonox/Main.cc	(revision 5929)
@@ -31,11 +31,9 @@
 @file
 @brief
-    The main function of Orxonox.
+    The main function of Orxonox (but not the entry point of the program!)
 */
 
 #include "OrxonoxPrereqs.h"
-#include "SpecialConfig.h"
 
-#include "util/Exception.h"
 #include "core/CommandLine.h"
 #include "core/Game.h"
@@ -50,4 +48,5 @@
 SetCommandLineSwitch(dedicated).information("Start in dedicated server mode");
 SetCommandLineSwitch(standalone).information("Start in standalone mode");
+SetCommandLineSwitch(dedicatedClient).information("Start in dedicated client mode");
 
 DeclareToluaInterface(Orxonox);
@@ -57,5 +56,5 @@
     /**
     @brief
-        Main method. Game starts here (except for static initialisations).
+        Starting point of orxonox (however not the entry point of the program!)
     */
     int main(const std::string& strCmdLine)
@@ -67,11 +66,7 @@
         " graphics"
         "  mainMenu"
-        "  standalone"
+        "  standalone,server,client"
         "   level"
-        "  server"
-        "   level"
-        "  client"
-        "   level"
-        " dedicated"
+        " dedicated,dedicatedClient"
         "  level"
         " ioConsole"
@@ -89,4 +84,6 @@
         else if (CommandLine::getValue("dedicated").getBool())
             Game::getInstance().requestStates("dedicated, level");
+        else if (CommandLine::getValue("dedicatedClient").getBool())
+            Game::getInstance().requestStates("dedicatedClient, level");
         else if (CommandLine::getValue("console").getBool())
             Game::getInstance().requestStates("ioConsole");
Index: /code/trunk/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 5928)
+++ /code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 5929)
@@ -28,6 +28,7 @@
 
 /**
-  @file
-  @brief Contains all the necessary forward declarations for all classes and structs.
+@file
+@brief
+    Shared library macros, enums, constants and forward declarations for the orxonox library
 */
 
@@ -36,5 +37,4 @@
 
 #include "OrxonoxConfig.h"
-
 #include "tools/ToolsPrereqs.h"
 
@@ -42,4 +42,5 @@
 // Shared library settings
 //-----------------------------------------------------------------------
+
 #if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
 #  ifdef ORXONOX_SHARED_BUILD
@@ -65,69 +66,73 @@
 {
     class CameraManager;
+    class Level;
     class LevelManager;
     class PawnManager;
     class PlayerManager;
-
-    class Level;
+    class Radar;
     class Scene;
-    class Tickable;
+
+    // collisionshapes
+    class CollisionShape;
+    class CompoundCollisionShape;
+    class WorldEntityCollisionShape;
+
+    // controllers
+    class AIController;
+    class ArtificialController;
+    class Controller;
+    class HumanController;
+    class ScriptController;
+    class WaypointController;
+    class WaypointPatrolController;
+
+    // gametypes
+    class Asteroids;
+    class Deathmatch;
+    class Gametype;
+    class TeamBaseMatch;
+    class TeamDeathmatch;
+    class UnderAttack;
+
+    // graphics
+    class Backlight;
+    class Billboard;
+    class BlinkingBillboard;
+    class Camera;
+    class FadingBillboard;
+    class GlobalShader;
+    class Light;
+    class Model;
+    class ParticleEmitter;
+    class ParticleSpawner;
+
+    // infos
+    class Bot;
+    class GametypeInfo;
+    class HumanPlayer;
+    class Info;
+    class PlayerInfo;
 
     // interfaces
     class GametypeMessageListener;
     class NotificationListener;
-    class PawnListener;
     class PlayerTrigger;
     class RadarListener;
     class RadarViewable;
     class Rewardable;
-    class Teamcolourable;
-
-    // worldentities
-    class WorldEntity;
-    class StaticEntity;
-    class MobileEntity;
-    class ControllableEntity;
-    class MovableEntity;
-
-    // graphics
-    class Model;
-    class Billboard;
-    class BlinkingBillboard;
-    class BigExplosion;
-    class ExplosionChunk;
-    class FadingBillboard;
-    class GlobalShader;
-    class Light;
-    class Backlight;
-    class ParticleEmitter;
-    class ParticleSpawner;
-    class Camera;
-
-    // mixed
-    class SpawnPoint;
-    class TeamSpawnPoint;
-
-    class CameraPosition;
-    class Sublevel;
-    class Radar;
-
-    class Test;
-
-    // pawns
-    class Spectator;
-    class Pawn;
-    class SpaceShip;
-    class TeamBaseMatchBase;
-    class Destroyer;
-
-    // gametypes
-    class Gametype;
-    class Deathmatch;
-    class TeamDeathmatch;
-    class Asteroids;
-    class TeamBaseMatch;
-    class UnderAttack;
-
-    // pickups
+    class TeamColourable;
+
+    // items
+    class Engine;
+    class Item;
+    class MultiStateEngine;
+
+    // overlays
+    class InGameConsole;
+    class Map;
+    class OrxonoxOverlay;
+    class OverlayGroup;
+
+    // pickup
     class BaseItem;
     class DroppedItem;
@@ -139,58 +144,42 @@
     class PickupSpawner;
     class UsableItem;
-
+    // pickup, items
+    class HealthImmediate;
+    class HealthUsable;
     class Jump;
-    class HealthUsable;
-    class PassiveItem;
-
-    // items
-    class Item;
-    class Engine;
-    class MultiStateEngine;
-    class RotatingEngine;
+
+    //sound
+    class AmbientSound;
+    class BaseSound;
+    class SoundManager;
+    class WorldSound;
 
     // weaponsystem
-    class WeaponSystem;
+    class DefaultWeaponmodeLink;
+    class Munition;
+    class Weapon;
+    class WeaponMode;
+    class WeaponPack;
     class WeaponSet;
     class WeaponSlot;
-    class WeaponPack;
-    class Weapon;
-    class WeaponMode;
-    class DefaultWeaponmodeLink;
-    class Munition;
-
-    // controller
-    class Controller;
-    class HumanController;
-    class ArtificialController;
-    class AIController;
-    class ScriptController;
-    class WaypointController;
-    class WaypointPatrolController;
-
-    // infos
-    class Info;
-    class PlayerInfo;
-    class HumanPlayer;
-    class Bot;
-    class GametypeInfo;
-
-    // collision
-    class CollisionShape;
-    class CompoundCollisionShape;
-    class WorldEntityCollisionShape;
-
-    // overlays
-    class OverlayGroup;
-    class OrxonoxOverlay;
-    class Notification;
-    class NotificationManager;
-    class InGameConsole;
-    class Map;
-
-    //sound
-    class SoundBase;
-    class SoundManager;
-    class SoundMainMenu;
+    class WeaponSystem;
+
+    // worldentities
+    class BigExplosion;
+    class CameraPosition;
+    class ControllableEntity;
+    class ExplosionChunk;
+    class MobileEntity;
+    class MovableEntity;
+    class SpawnPoint;
+    class StaticEntity;
+    class TeamSpawnPoint;
+    class WorldEntity;
+    // worldentities, pawns
+    class Destroyer;
+    class Pawn;
+    class SpaceShip;
+    class Spectator;
+    class TeamBaseMatchBase;
 }
 
Index: /code/trunk/src/orxonox/PawnManager.cc
===================================================================
--- /code/trunk/src/orxonox/PawnManager.cc	(revision 5928)
+++ /code/trunk/src/orxonox/PawnManager.cc	(revision 5929)
@@ -57,5 +57,5 @@
         {
             if (!it->isAlive())
-                delete (*(it++));
+                (it++)->destroy();
             else
                 ++it;
@@ -63,5 +63,5 @@
 
         if (count == 0)
-            delete this;
+            this->destroy();
     }
 }
Index: /code/trunk/src/orxonox/PlayerManager.cc
===================================================================
--- /code/trunk/src/orxonox/PlayerManager.cc	(revision 5928)
+++ /code/trunk/src/orxonox/PlayerManager.cc	(revision 5929)
@@ -31,4 +31,5 @@
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
+#include "core/ScopedSingletonManager.h"
 #include "Level.h"
 #include "infos/HumanPlayer.h"
@@ -38,4 +39,5 @@
 {
     PlayerManager* PlayerManager::singletonPtr_s = 0;
+    ManageScopedSingleton(PlayerManager, ScopeID::Root, false);
 
     PlayerManager::PlayerManager()
@@ -74,5 +76,6 @@
         if (GameMode::isMaster())
         {
-            COUT(3) << "client disconnected" << std::endl;
+            if (clientID != 0)
+                COUT(3) << "client disconnected" << std::endl;
 
             // remove from clients-map
@@ -85,5 +88,5 @@
             // delete PlayerInfo instance
             if (player)
-                delete player;
+                player->destroy();
         }
     }
Index: /code/trunk/src/orxonox/Radar.cc
===================================================================
--- /code/trunk/src/orxonox/Radar.cc	(revision 5928)
+++ /code/trunk/src/orxonox/Radar.cc	(revision 5929)
@@ -43,8 +43,4 @@
 namespace orxonox
 {
-    SetConsoleCommand(Radar, cycleNavigationFocus, true).accessLevel(AccessLevel::User);
-    SetConsoleCommand(Radar, releaseNavigationFocus, true).accessLevel(AccessLevel::User);
-
-    Radar* Radar::instance_s = 0;
 
     Radar::Radar()
@@ -52,7 +48,4 @@
         , objectTypeCounter_(0)
     {
-        assert(instance_s == 0);
-        instance_s = this;
-
         // TODO: make this mapping configurable. Maybe there's a possibility with self configured
         //       configValues..
@@ -79,10 +72,12 @@
     Radar::~Radar()
     {
-        instance_s = 0;
     }
 
     const RadarViewable* Radar::getFocus()
     {
-        return *(this->itFocus_);
+        if (this->itFocus_)
+            return *(this->itFocus_);
+        else
+            return 0;
     }
 
@@ -101,5 +96,5 @@
         SUPER(Radar, tick, dt);
 
-        if (this->focus_ != *(this->itFocus_))
+        if (this->itFocus_ && (this->focus_ != *(this->itFocus_)))
         {
             // focus object was deleted, release focus
@@ -191,26 +186,3 @@
         }
     }
-
-
-    /*static*/ Radar& Radar::getInstance()
-    {
-        assert(instance_s);
-        return *instance_s;
-    }
-
-    /*static*/ void Radar::cycleNavigationFocus()
-    {
-        // avoid using getInstance because of the assert().
-        // User might call this fuction even if HUDNavigation doesn't exist.
-        if (instance_s)
-            instance_s->cycleFocus();
-    }
-
-    /*static*/ void Radar::releaseNavigationFocus()
-    {
-        // avoid using getInstance because of the assert().
-        // User might call this fuction even if HUDNavigation doesn't exist.
-        if (instance_s)
-            instance_s->releaseFocus();
-    }
 }
